#!/usr/bin/perl5 -w

#mrtgsvchost_total

#########################################################################
# 20 Oct 1999 - 10:50 Ver 2.2						#
# Written By Richard Mayhew - South Africa				#
# Email : netsaint@splash.co.za						#
# Copyright 1999 (c) Richard Mayhew					#
# Credits go to Ethan Galstad for coding NetSaint			#
# If any changes are made to this script, please mail me a copy of the	#
# changes :)	netsaint@splash.co.za					#	
# This Script will obtain the total number for services up & down for a	# 
# particular server							#
#									#
# Usage mrtgsvctyp_total.pl [Server] (for a string include " ")		#
# THIS IS CASE SENSATIVE ie PING AND ping ARE DIFFERENT!!!!!!!		#
# ./mrtgsvchost_total.pl Server						#
# ./mrtgsvchost_total.pl "Server A" NB!! include " before and after	#
# Recommendation - MRTG Knowledge hence I dont support MRTG :)		#
#									#
# Comments / Additions - 1.0 = Ethan Galstad				#	
#########################################################################

#---------------------------------------------VARIABLES
#Using A Default Service Of PING incase its left out
my $host = shift || NULL;

#Location of GREP program (ie /bin/grep)
$greplocation = "/bin/grep";

#Location of NetSaint status.log Data (ie /usr/local/netsaint)
$statuslog = "/usr/local/netsaint/var/status.log";
#Location of UPTIME program (ie /usr/bin/uptime)
$time = `/usr/bin/uptime`;
#Location of HOSTNAME program (ie /bin/hostname)
$hostname = `/bin/hostname`;


#-----------------------------------------------PROGRAM


#Commands For Obtaining Data

$up = `$greplocation 'SERVICE;$host;' $statuslog | $greplocation -c ';OK;'`;
$recovery = `$greplocation 'SERVICE;$host;' $statuslog | $greplocation  -c ';RECOVERY;'`;

$warning = `$greplocation 'SERVICE;$host;' $statuslog | $greplocation  -c ';WARNING;'`;
$down = `$greplocation 'SERVICE;$host;' $statuslog | $greplocation  -c ';DOWN;'`;
$critical = `$greplocation 'SERVICE;$host;' $statuslog | $greplocation  -c ';CRITICAL;'`;
$unreachable = `$greplocation 'SERVICE;$host;' $statuslog | $greplocation  -c ';UNREACHABLE;'`;
$unknown = `$greplocation 'SERVICE;$host;' $statuslog | $greplocation  -c ';UNKNOWN;'`;

#Adding DOWN and CRITICAL totals 
$totaldown = $down + $critical + $unreachable + $unknown + $warning;
$totalup = $up + $recovery;


#Writing Data To Disk
print "$totalup\n";
print "$totaldown\n";
print "$time";
print "$hostname";

#The End :)
