#!/usr/bin/perl5 -w

#mrtgsvctyp_total

#########################################################################
# 20 Oct  1999 - 10:50 Ver 2.2						#
# Written By Richard Mayhew - South Africa				#
# Email : netsaint@splash.co.za						#
# Copyright 1999 (c) Richard Mayhew					#
# Credits go to Ethan Galstad for coding NetSaint			#
# If any changes are made to this script, please mail me a copy of the	#
# changes :)	netsaint@splash.co.za					#	
# This Script will obtain the total number for a particular type	# 
# of servicei for MRTG							#
#									#
# Usage mrtgsvctyp_total.pl [Service] (for a string include " ")	#
# THIS IS CASE SENSATIVE ie PING AND ping ARE DIFFERENT!!!!!!!		#
# ./mrtgsvctyp_total.pl PING						#
# ./mrtgsvctyp_total.pl "Root Drive" NB!! include " before and after	#
#									#
#########################################################################

#---------------------------------------------VARIABLES
#Using A Default Service Of PING incase its left out
my $service = shift || PING;

#Location of GREP program (ie /bin/grep)
$greplocation = "/bin/grep";

#Location of NetSaint status.log Data (ie /usr/local/netsaint)
$statuslog = "/usr/local/netsaint/var/status.log";
#Location of UPTIME program (ie /usr/bin/uptime)
$time = `/usr/bin/uptime`;
#location of HOSTNAME program (ie /bin/hostname)
$hostname = `/bin/hostname`;

#-----------------------------------------------PROGRAM


#Commands For Obtaining Data
$up = `$greplocation 'SERVICE;' $statuslog | $greplocation -c ';$service;OK;'`;
$recovery = `$greplocation 'SERVICE;' $statuslog | $greplocation -c ';$service;RECOVERY;'`;

$warning = `$greplocation 'SERVICE;' $statuslog | $greplocation -c ';$service;WARNING;'`;
$unknown = `$greplocation 'SERVICE;' $statuslog | $greplocation -c ';$service;UNKNOWN;'`;
$critical = `$greplocation 'SERVICE;' $statuslog | $greplocation -c ';$service;CRITICAL;'`;
$unreachable = `$greplocation 'SERVICE;' $statuslog | $greplocation -c ';$service;UNREACHABLE;'`;
$down = `$greplocation 'SERVICE;' $statuslog | $greplocation -c ';$service;DOWN;'`;

#Adding DOWN and CRITICAL totals 
$totaldown = $down + $critical + $unreachable + $warning + $unknown;
$totalup = $up + $recovery;

#Writing Data To Disk
print "$totalup\n";
print "$totaldown\n";
print "$time";
print "$hostname";

#The End :)
